%{?!_licensedir:%global license %%doc}
%{!?upstream_version: %global upstream_version %{version}}

Name:       openstack-ironic-python-agent
Summary:    A python agent for provisioning and deprovisioning bare metal servers
Version:    1.1.0
Release:    10%{?dist}
License:    ASL 2.0
URL:        https://github.com/openstack/ironic-python-agent

Source0:    https://pypi.python.org/packages/source/i/ironic-python-agent/ironic-python-agent-%{version}.tar.gz
Source1:    openstack-ironic-python-agent.service

#patches_base=+1
Patch0001: 0001-Add-system_vendor-information-to-data.patch
Patch0002: 0002-Allow-enabling-debug-level-via-kernel-cmdline.patch
Patch0003: 0003-Reduced-restriction-of-parsing-for-dmidecode-output.patch
Patch0004: 0004-Wait-for-udev-to-settle-before-listing-the-block-dev.patch
Patch0005: 0005-Respect-disk-kernel-argument-for-better-compatibilit.patch
Patch0006: 0006-Bind-to-interface-routable-to-the-ironic-host-not-a-.patch
Patch0007: 0007-Wait-for-the-interfaces-to-get-IP-addresses-before-i.patch
Patch0008: 0008-inspection-wait-for-the-PXE-DHCP-by-default-and-remo.patch
Patch0009: 0009-Wait-for-at-least-one-suitable-disk-to-appear-on-sta.patch

BuildArch:  noarch
BuildRequires:  python-setuptools
BuildRequires:  python-pbr
BuildRequires:  python2-devel
BuildRequires:  systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires:       python-rtslib

# TODO(trown) when the following packages are available, package for py3:
# python3-eventlet
# python3-oslo-concurrency
# python3-oslo-i18n
# python3-oslo-log
# python3-oslo-serialization
# python3-oslo-service
# python3-oslo-utils
# python3-pecan
# python3-pint
# python3-wsme

Requires: python-pbr
Requires: python-babel
Requires: python-eventlet
Requires: python-iso8601
Requires: python-netifaces
Requires: python-oslo-config
Requires: python-oslo-concurrency
Requires: python-oslo-i18n
Requires: python-oslo-log
Requires: python-oslo-serialization
Requires: python-oslo-service
Requires: python-oslo-utils
Requires: python-pecan
Requires: python-pint
Requires: python-psutil
Requires: python-pyudev
Requires: python-requests
Requires: python-six
Requires: python-stevedore
Requires: python-wsme

%description
An agent for controlling and deploying Ironic controlled bare metal nodes.

The ironic-python-agent works with the agent driver in Ironic to provision the
node. Starting with ironic-python-agent running on a ramdisk on the
unprovisioned node, Ironic makes API calls to ironic-python-agent to provision
the machine. This allows for greater control and flexibility of the entire
deployment process.

The ironic-python-agent may also be used with the original Ironic pxe drivers
as of the Kilo OpenStack release.

%package -n ironic-python-agent-doc
Summary:    Documentation for ironic python agent.
Group:      Documentation
Provides:   ironic-python-agent-doc = %{upstream_version}

%description -n ironic-python-agent-doc
Documentation for ironic python agent.

%prep
%autosetup -v -p 1 -n ironic-python-agent-%{upstream_version}
rm -rf *.egg-info

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}

# TODO(trown) build the docs as below once we either remove the upstream
# requirement on python-sphinxcontrib-pecanwsme, or it exists in rawhide.
# For now, we will just include the raw restructured text.
# export PYTHONPATH="$( pwd ):$PYTHONPATH"
# pushd doc
# sphinx-build -b html -d build/doctrees  source build/html
# popd

# install systemd scripts
mkdir -p %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}

install -p -D -m 644 etc/ironic_python_agent/ironic_python_agent.conf.sample %{buildroot}/%{_sysconfdir}/ironic-python-agent/agent.conf

%files
%doc README.rst
%license LICENSE
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/ironic-python-agent
%{_bindir}/ironic-python-agent
%{_unitdir}/openstack-ironic-python-agent.service
%{python2_sitelib}/ironic_python_agent*
# TODO(trown) add egg-info once the agent is released on pypi

%files -n ironic-python-agent-doc
%doc doc/source
%license LICENSE

%post
%systemd_post openstack-ironic-python-agent.service

%preun
%systemd_preun openstack-ironic-python-agent.service

%postun
%systemd_postun_with_restart openstack-ironic-python-agent.service


%changelog
* Thu May 26 2016 Steve Linabery <slinaber@redhat.com> 1.1.0-10
- Wait for at least one suitable disk to appear on start up

* Wed May 11 2016 Steve Linabery <slinaber@redhat.com> 1.1.0-9
- [inspection] wait for the PXE DHCP by default and remove the carrier check
- Wait for the interfaces to get IP addresses before inspection

* Wed Mar 23 2016 Thierry Vignaud <<tvignaud@redhat.com>> 1.1.0-8
- Bind to interface routable to the ironic host, not a random one (rhbz#1308981)

* Wed Mar 16 2016 Steve Linabery <slinaber@redhat.com> 1.1.0-7
- Respect "disk" kernel argument for better compatibility with the old ramdisk
- rhbz#1314642

* Wed Mar 09 2016 Mike Burns <mburns@redhat.com> 1.1.0-6
- Wait for udev to settle before listing the block devices

* Wed Mar 02 2016 Mike Burns <mburns@redhat.com> 1.1.0-5
- Reduced restriction of parsing for dmidecode output

* Wed Mar 02 2016 Mike Burns <mburns@redhat.com> 1.1.0-4
- Mark systemd service depend on network.service

* Fri Feb 26 2016 Steve Linabery <slinaber@redhat.com> 1.1.0-3
- Allow enabling debug level via kernel cmdline

* Mon Feb 22 2016 Mike Burns <mburns@redhat.com> 1.1.0-2
- Add 'system_vendor' information to data

* Tue Jan 12 2016 Mike Burns <mburns@redhat.com> 1.1.0-1
- Update to 1.1.0

* Fri Oct 16 2015 John Trowbridge <trown@redhat.com> 1.0.0-1
- Update to upstream 1.0.0


* Wed Aug 26 2015 John Trowbridge <trown@redhat.com> - 0.1.0-0.1gite6439ca1d06a50e72b97975da9b3963ba04ba841
- Initial package build
